
Foreman - Bug #13354

unable to show puppet certificates lists when there are pending certificates

01/25/2016 06:56 AM - Ohad Levy

Status: Closed   

Priority: Normal   

Assignee: Tomer Brisker   

Category: Smart Proxy   

Target version: 1.11.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: Nightly

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/3116

  

Description

endered smart_proxies/plugins/_puppet_envs.html.erb (4.6ms)

2016-01-25T11:49:22 [app] [I] Completed 200 OK in 52ms (Views: 8.8ms | ActiveRecord: 15.8ms)

2016-01-25T11:49:22 [app] [I]   Rendered dashboard/_reports_widget.html.erb (128.3ms)

2016-01-25T11:49:22 [app] [I]   Rendered dashboard/_distribution_widget.html.erb (38.5ms)

2016-01-25T11:49:22 [app] [I]   Rendered dashboard/_status_chart_widget.html.erb (3.6ms)

2016-01-25T11:49:22 [app] [I]   Rendered smart_proxies/plugins/_puppet_dashboard.html.erb (181.1ms

)

2016-01-25T11:49:22 [app] [I] Completed 200 OK in 272ms (Views: 178.4ms | ActiveRecord: 20.3ms)

2016-01-25T11:49:23 [app] [W] Action failed

 | ArgumentError: comparison of NilClass with Time failed

 | /home/foreman/git/foreman/app/services/proxy_status/puppetca.rb:7:in `sort_by'

 | /home/foreman/git/foreman/app/services/proxy_status/puppetca.rb:7:in `sort_by!'

 | /home/foreman/git/foreman/app/services/proxy_status/puppetca.rb:7:in `block in certs'

 | /home/foreman/git/foreman/app/services/proxy_status/base.rb:40:in `block in fetch_proxy_data'

 | /home/foreman/gems/gems/dalli-2.7.5/lib/active_support/cache/dalli_store.rb:113:in `block in fe

tch'

 | /home/foreman/gems/gems/dalli-2.7.5/lib/active_support/cache/dalli_store.rb:370:in `block in in

strument'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/notifications.rb:161:in `instrum

ent'

 | /home/foreman/gems/gems/dalli-2.7.5/lib/active_support/cache/dalli_store.rb:370:in `instrument'

 | /home/foreman/gems/gems/dalli-2.7.5/lib/active_support/cache/dalli_store.rb:112:in `fetch'

 | /home/foreman/git/foreman/app/services/proxy_status/base.rb:39:in `fetch_proxy_data'

 | /home/foreman/git/foreman/app/services/proxy_status/puppetca.rb:4:in `certs'

 | /home/foreman/git/foreman/app/controllers/puppetca_controller.rb:4:in `index'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_controller/metal/implicit_render.rb:4:in `s

end_action'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/abstract_controller/base.rb:189:in `process_action

'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_controller/metal/rendering.rb:10:in `proces

s_action'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/abstract_controller/callbacks.rb:20:in `block in p

rocess_action'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:113:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:113:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:299:in `block (2 le

vels) in halting'

 | /home/foreman/gems/gems/rails-observers-0.1.2/lib/rails/observers/action_controller/caching/swe

eping.rb:73:in `around'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:447:in `public_send

'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:447:in `block in ma

ke_lambda'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:298:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:298:in `block in ha

05/18/2024 1/5



lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:299:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:299:in `block (2 le

vels) in halting'

 | /home/foreman/git/foreman/app/controllers/concerns/application_shared.rb:13:in `set_timezone'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:424:in `block in ma

ke_lambda'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:298:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:298:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:149:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:149:in `block in ha

lting_and_conditional'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:149:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:149:in `block in ha

lting_and_conditional'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:149:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:149:in `block in ha

lting_and_conditional'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:229:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:229:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:149:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:149:in `block in ha

lting_and_conditional'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:299:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:299:in `block (2 le

vels) in halting'
 | /home/foreman/git/foreman/app/models/concerns/foreman/thread_session.rb:32:in `clear_thread'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:424:in `block in ma

ke_lambda'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:298:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:298:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:229:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:229:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:299:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:299:in `block (2 le

vels) in halting'

 | /home/foreman/gems/gems/rails-observers-0.1.2/lib/rails/observers/action_controller/caching/swe

eping.rb:73:in `around'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:447:in `public_send

'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:447:in `block in ma

ke_lambda'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:298:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:298:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:166:in `block in ha

lting'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:86:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:86:in `run_callback

s'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/abstract_controller/callbacks.rb:19:in `process_ac

tion'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_controller/metal/rescue.rb:29:in `process_a

ction'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_controller/metal/instrumentation.rb:31:in `

block in process_action'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/notifications.rb:159:in `block i

n instrument'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/notifications/instrumenter.rb:20

:in `instrument'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/notifications.rb:159:in `instrum

ent'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_controller/metal/instrumentation.rb:30:in `

process_action'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_controller/metal/params_wrapper.rb:250:in `

process_action'

 | /home/foreman/gems/gems/activerecord-4.1.5/lib/active_record/railties/controller_runtime.rb:18:

in `process_action'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/abstract_controller/base.rb:136:in `process'

 | /home/foreman/gems/gems/actionview-4.1.5/lib/action_view/rendering.rb:30:in `process'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_controller/metal.rb:196:in `dispatch'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_controller/metal/rack_delegation.rb:13:in `

dispatch'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_controller/metal.rb:232:in `block in action

'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/routing/route_set.rb:82:in `call'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/routing/route_set.rb:82:in `dispat

ch'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/routing/route_set.rb:50:in `call'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/journey/router.rb:71:in `block in 

call'
 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/journey/router.rb:59:in `each'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/journey/router.rb:59:in `call'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/routing/route_set.rb:678:in `call'

 | /home/foreman/gems/gems/apipie-rails-0.3.5/lib/apipie/static_dispatcher.rb:65:in `call'

 | /home/foreman/gems/gems/apipie-rails-0.3.5/lib/apipie/extractor/recorder.rb:132:in `call'

 | /home/foreman/gems/gems/apipie-rails-0.3.5/lib/apipie/middleware/checksum_in_headers.rb:27:in `

call'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/etag.rb:23:in `call'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/conditionalget.rb:25:in `call'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/head.rb:11:in `call'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/params_parser.rb:27:in 

`call'

 | /home/foreman/git/foreman/lib/middleware/catch_json_parse_errors.rb:9:in `call'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/flash.rb:254:in `call'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/session/abstract/id.rb:225:in `context'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/session/abstract/id.rb:220:in `call'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/cookies.rb:560:in `call

'

 | /home/foreman/gems/gems/activerecord-4.1.5/lib/active_record/query_cache.rb:36:in `call'

 | /home/foreman/gems/gems/activerecord-4.1.5/lib/active_record/connection_adapters/abstract/conne

ction_pool.rb:621:in `call'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/callbacks.rb:29:in `blo

ck in call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:82:in `run_callback

s'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/callbacks.rb:27:in `cal

l'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/remote_ip.rb:76:in `cal

l'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/debug_exceptions.rb:17:

in `call'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/show_exceptions.rb:30:i

n `call'

 | /home/foreman/gems/gems/railties-4.1.5/lib/rails/rack/logger.rb:38:in `call_app'

 | /home/foreman/gems/gems/railties-4.1.5/lib/rails/rack/logger.rb:22:in `call'

 | /home/foreman/gems/gems/quiet_assets-1.1.0/lib/quiet_assets.rb:27:in `call_with_quiet_assets'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/request_id.rb:21:in `ca

ll'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/methodoverride.rb:21:in `call'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/runtime.rb:17:in `call'

 | /home/foreman/gems/gems/activesupport-4.1.5/lib/active_support/cache/strategy/local_cache_middl

eware.rb:26:in `call'

 | /home/foreman/gems/gems/actionpack-4.1.5/lib/action_dispatch/middleware/static.rb:64:in `call'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/sendfile.rb:112:in `call'

 | /home/foreman/gems/gems/railties-4.1.5/lib/rails/engine.rb:514:in `call'

 | /home/foreman/gems/gems/railties-4.1.5/lib/rails/application.rb:144:in `call'

 | /home/foreman/gems/gems/railties-4.1.5/lib/rails/railtie.rb:194:in `public_send'

 | /home/foreman/gems/gems/railties-4.1.5/lib/rails/railtie.rb:194:in `method_missing'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/builder.rb:138:in `call'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/urlmap.rb:65:in `block in call'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/urlmap.rb:50:in `each'

 | /home/foreman/gems/gems/rack-1.5.5/lib/rack/urlmap.rb:50:in `call'

 | /root/.gem/gems/passenger-5.0.7/lib/phusion_passenger/rack/thread_handler_extension.rb:89:in `p

rocess_request'

 | /root/.gem/gems/passenger-5.0.7/lib/phusion_passenger/request_handler/thread_handler.rb:149:in 

`accept_and_process_next_request'

 | /root/.gem/gems/passenger-5.0.7/lib/phusion_passenger/request_handler/thread_handler.rb:110:in 

`main_loop'

 | /root/.gem/gems/passenger-5.0.7/lib/phusion_passenger/request_handler.rb:414:in `block (3 level

s) in start_threads'

 | /root/.gem/gems/passenger-5.0.7/lib/phusion_passenger/utils.rb:111:in `block in create_thread_a

nd_abort_on_exception'

 | /home/foreman/gems/gems/logging-2.0.0/lib/logging/diagnostic_context.rb:448:in `call'

 | /home/foreman/gems/gems/logging-2.0.0/lib/logging/diagnostic_context.rb:448:in `block in create

_with_logging_context'

2016-01-25T11:49:23 [app] [I]   Rendered common/500.html.erb (1.7ms)

2016-01-25T11:49:23 [app] [I] Completed 500 Internal Server Error in 1863ms (Views: 2.6ms | Active
Record: 63.8ms)

 it seems like the output of puppet ca changed at some point, it used to be called not_{before, after} in the api response, I assume we

could probably support both names on foreman side.

Related issues:

Related to Foreman - Feature #12720: As a User I would like to get puppet rel... Closed 12/07/2015

Associated revisions

Revision df5950e3 - 01/26/2016 03:51 AM - Tomer Brisker

Fixes #13354 - Correctly show certificates even if some are pending

History

#1 - 01/25/2016 06:58 AM - Ohad Levy

I take it back, not_before / after is currently part of the api, thats not the cause.

#2 - 01/25/2016 07:01 AM - Ohad Levy

- Subject changed from unable to show puppet certificates on older puppet versions to unable to show puppet certificates lists when there are pending

certificates

certificate time stamps do not exists when the certificate is in pending state.

#3 - 01/25/2016 07:02 AM - Ohad Levy

- Related to Feature #12720: As a User I would like to get puppet related data of the smart proxy added

#4 - 01/25/2016 07:07 AM - Tomer Brisker

- Category set to Smart Proxy

- Status changed from New to Assigned

- Assignee set to Tomer Brisker

#5 - 01/25/2016 07:35 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3116 added

#6 - 01/26/2016 04:05 AM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset df5950e354bb6f0f91873f6d14346aed61f6f4ad.

#7 - 01/26/2016 04:09 AM - Dominic Cleal

- translation missing: en.field_release set to 71
